#!/bin/sh

# This file will be used to create OpenSSL keys and launch HTTPS

# HTTPS bootup / unique key generation 
# Automates OpenSSL key generation process

DIRECTORY="/etc/lighttpd/ssl/theos.in"

	if [ ! -d $DIRECTORY ]
		then		
		# Create necessary directory
		echo "ICX20-HTTPS: Creating Directories..."
		mkdir -p /etc/lighttpd/ssl/theos.in
		cd /etc/lighttpd/ssl/theos.in

		# Generate initial RSA key
		echo "ICX20-HTTPS: Generating RSA..."
		openssl genrsa -des3 -out theos.in.key -passout pass:prosoft 1024
		echo "ICX20-HTTPS: Copying config..."
		cp /psft/etc/httpsBootConfig.conf /etc/lighttpd/ssl/theos.in/httpsBootConfig.conf
		echo "ICX20-HTTPS: Creating csr with config..."
		openssl req -new -config httpsBootConfig.conf -out theos.in.csr

		# Generate unsigned key
		echo "ICX20-HTTPS: Generating x509..."
		openssl x509 -req -days 365 -in theos.in.csr -signkey theos.in.key -passin pass:prosoft -out theos.in.crt 

		# Copy cert file to proper location
		echo "ICX20-HTTPS: Copy Cert file..."
		cp theos.in.crt /etc/lighttpd/ssl/theos.in

		# Create final pem used for lighttpd
		echo "ICX20-HTTPS: Generate final pem file..."
		cat theos.in.key theos.in.crt > theos.in.pem
		chmod 0600 theos.in.pem
		chown lighttpd:lighttpd /etc/lighttpd/ssl/theos.in -R

		# Create backups
		echo "ICX20-HTTPS: Create backups..."
		cp theos.in.key theos.in.key.bak
		cp theos.in.pem theos.in.pem.bak

		# final pem generation / final steps / password removal
		echo "ICX20-HTTPS: Final steps..."
		openssl rsa -in theos.in.key -out no.pwd.theos.in.key -passin pass:prosoft -passout pass:prosoft
		cat no.pwd.theos.in.key theos.in.crt > theos.in.pem
		
	fi
	exit 1
