#!/bin/sh

# STR = ARG[0] -> IP ADDRESS
# TYPE = ARG[1] -> TYPE OF INTERFACE
# eth0 (LAN), ppp0(WAN)


# Input variables and match request
STR=$2
TYPE=$1
MATCH=0000

# Argument input check
if [ -z "$STR" ]
  then
    echo
    echo "No argument supplied"
    echo "  Please supply: Interface and IP address"
    echo "  e.g. ./icx20-ping.sh eth0 192.168.0.1"
    echo
    exit 1
fi

ping_fork()
{
    # badPing - 100% packet loss as return variable means no transmission
    badPing="100% packet loss"
    # ping source from specific iface and store it in pingData
    pingData=$(ping -I $1 -c 2 -w 7 -s 1 $2)
	
    # compare ping information with key to see if it matches
    # if successful ping, pingKey will match
	if echo "$pingData" | grep -q "$badPing"; then
		#Return bad value for ping for 100% packet loss
		echo 0001
	elif [ -z "$pingData" ] 
		#Return bad balue for ping with bad address (null value)
		then
		echo 0001
	else
		#Return successful value for ping
		echo 0000
	fi

}

# Fork process for ping and return all results to pingResult
pingResult=$(ping_fork $TYPE $STR &)

# Check pingResult with MATCH vale from ping_fork() as
# a master match
if echo "$pingResult" | grep -q "$MATCH"; then
     echo PING SUCCESSFUL: $2
     exit 0

 else
     echo UNABLE TO RESOLVE HOST: $2
     exit 1
fi
