#!/bin/sh
#
# ipwatchd config generator
#

export LD_LIBRARY_PATH=/psft/lib

# ICX35 system command wrapper functions
source /psft/scripts/icx35-syscom.sh

case "$1" in
	configure)
		printf "Generating /tmp/ipwatchd.conf config file... "
		cat > /tmp/ipwatchd.conf << _EOF
# IPwatchD configuration file
# See ipwatchd.conf(5) for more details

iface_configuration automatic
#iface eth0 active
#iface eth0:0 passive
defend_interval 10
user_script /psft/scripts/icx35-ipwatchd.sh signal
syslog_facility daemon

_EOF
	;;
	signal)
		kill -SIGUSR1 $(pidof icx20eip eth0)
	;;
	arping)
		icx35ConfigRead lanIPAddr lan/ipadr
		while true
		do
			icx35ConfigRead eipEnable system/eipenable
			if test "$eipEnable" == "1" ; then
				icx35ARPPing result eth0 "$lanIPAddr"

				if test "$result" == "1" && test "$(/bin/pidof icx20eip eth0)" ; then
					kill -SIGUSR1 $(/bin/pidof icx20eip eth0)
				elif test "$result" == "0" && test "$(/bin/pidof icx20eip eth0)" ; then
					kill -SIGUSR2 $(/bin/pidof icx20eip eth0)
				fi
				sleep 10
			fi
		done
	;;
esac
