#!/bin/sh

# Monitor ProSoft processes every 1 minute


# ProSoft Connect cloud agent process
agent_url=wss://prosoft.io/device-gateway/manager

psft_pid=$(pidof agent)
if [[ -z $psft_pid ]]; then
    /usr/bin/logger -t "ICX35ProcessMonitor" -p USER.ERROR -s "ProSoft Connect cloud agent died! Restarting it..."
    pkill vpnbridge
    sleep 2
    /sbin/vpnbridge start &> /dev/null
    echo "bridgecreate bridge /device:eth0" > /tmp/config.text
    /sbin/vpncmd /server 127.0.0.1 /in:/tmp/config.text &> /dev/null
    /bin/agent --url $agent_url --db /psft/etc/icx35.cfg --cert /opt/prosoft/agent/bin/prosoft.cer &> /dev/null &
fi


# cellCmdHandler
psft_pid=$(pidof cellCmdHandler)
COUNTER_FILE=/psft/etc/RadioCrashCnt
if [[ -z $psft_pid ]]; then
    if [[ -r $COUNTER_FILE ]] ; then
      COUNT=`cat $COUNTER_FILE`
    else
      COUNT=0
    fi
    COUNT=`expr $COUNT + 1`
    echo $COUNT > $COUNTER_FILE
    /usr/bin/logger -t "ICX35ProcessMonitor" -p USER.ERROR -s "cellCmdHandler died! Restarting it..."
    pkill -9 pppwd
    pkill -9 -f icx35_qmi_connect
    pkill -9 uqmi
    /bin/rm -f /dev/ttyUSB*
    /psft/bin/gpioModify resetCellMod
    sleep 2
    while [ ! -f /dev/ttyUSB* ]
    do
        sleep 3
    done
    /psft/bin/cellCmdHandler
    /psft/bin/pppwd &
    
# Reconfigure SMS
	/psft/bin/cellCmdRequest AT+CMGF=1
    /psft/bin/cellCmdRequest AT+CPMS=\"MT\",\"MT\",\"MT\"
    /psft/bin/cellCmdRequest AT+CSCS=\"GSM\"
    
    /usr/bin/logger -t "ICX35ProcessMonitor" -p USER.ERROR -s "Radio card crash count: $COUNT"
fi
