#!/bin/sh
#
# EtherNet/IP start/stop program Script
#
# This script will start the EtherNet/IP process
# by calling /psft/bin/icx20eip
#
# description: EtherNet/IP startup script

# ICX35 system command wrapper functions
source /psft/scripts/icx35-syscom.sh

export LD_LIBRARY_PATH=/psft/lib

# Query EIP enablement status
icx35ConfigRead eipEnable system/eipenable

# See how we were called.
case "$1" in
    start)
        printf "Starting EIP ... "

        if [ "1" == "$eipEnable" ]; then
            /psft/bin/icx20eip eth0 &
            /psft/bin/gpioModify setMS-GREEN 1
            nohup /psft/scripts/icx35-ipwatchd.sh arping 0<&- &>/dev/null &
            printf "Done.\n"
        else
            printf "\nEIP is currently disabled.\n"
        fi
    ;;
    restart)
        $0 stop
        $0 start
    ;;
    stop)
        printf "Stopping EIP ... "
        /usr/bin/pkill icx20eip
        /usr/bin/killall icx35-ipwatchd.sh
        rm -f /tmp/smsl*
        rm -f /tmp/sem.eipsem
        /psft/bin/gpioModify setMS-GREEN 0
        /psft/bin/gpioModify setNS-GREEN 0
        /psft/bin/gpioModify setNS-RED 0
        printf "Done.\n"
    ;;
  *)
    exit 1
esac

exit 0
