<?php
session_start();
require_once('../inc/userfunction.php');
require_once('../inc/common_file.php');
require_once('../inc/systemfunction.php');
require_once('../inc/filefunction.php');
require_once('../inc/config.inc.php');

// Check the login session
if (CheckUserSession() == false) {
    header("Location: /components/session_expired.php");
    exit;
}

$method = $_SERVER['REQUEST_METHOD'];
$csrf = $_POST['csrf'];

// Check the CSRF token
if (CheckCSRFToken($method, $csrf) == false) {
	error_log("Warning! Possible CSRF detected.", 0);
	exit;
}

$action=$_REQUEST['action'];
$saveall=$_REQUEST['all'];
$show = 0;
$validate_err=0;

if (null == $saveall) {
  $saveall = 0;
}

if ($action == 1 )
{
  $error = false;

  $temp = htmlspecialchars(trim($_POST['txt_loglevel']), ENT_QUOTES, 'UTF-8');
  if (!ctype_digit($temp) || ($temp < 1) || ($temp > 8)) {
    $errArray[$validate_err++] = "txt_loglevel";
    $section_err["tdCellUsage"] = true;
  }

  if (0 == $validate_err) {
  	$retval = ConfigWrite("module/loglevel", $temp);
    if (0 > $retval[0]) {
      echo "<script>alert('Error setting log level!');
          window.location = 'administrator_logs.php';</SCRIPT>";
      $error = true;
    }
    if (!$error) {
      $retval = ConfigToFlash();
      if (1 != $retval) {
        echo "<script>alert('Error saving new configuration: " . $retval . ");
              window.location = 'administrator_logs.php';</SCRIPT>";
      }
      exec("/psft/bin/reboot.sh &");
      echo "<script>window.location = 'rebooting.php';</script>";
    }
  }
}

if ($action == 2 )//archived
{
  $show="1";
}

/* clear logs */
if ($action == 4 )
{
      echo "<script>alert('Clearing logs');</SCRIPT>";
      exec("rm /tmp/messages*");
}

if ($action == 3) /* save log file */
{
  global $con;
  date_default_timezone_set("UTC");
  exec("rm " . $con[backfilepath] . "/icx35log*");
  $filename = "/icx35log_" . date('Y_M_d_H_i_s') . ".log";

  /*echo '<script>
    alert("Save clicked -- all = ' . $saveall . '\nSaving to ' . $filename . '");</SCRIPT>'; */
  $LogCmd = "cat";
  if ($saveall == 1) {
    $show="1";
    for($i=getArrayIndex(ConfigRead("module/lognumfiles"),0); $i > -1; $i--) {
      $LogCmd = $LogCmd . " /var/log/messages." . $i;
    }
  }
  $LogCmd = $LogCmd . " /tmp/messages > " . $con[backfilepath] . $filename;
  exec($LogCmd);
  
  if (file_exists($con[backfilepath] . $filename)) {
    header('Content-Description: File Transfer');
    header('Content-Type: application/octet-stream');
    header('Content-Disposition: attachment; filename='.basename($con[backfilepath] . $filename));
    header('Expires: 0');
    header('Cache-Control: must-revalidate');
    header('Pragma: public');
    header('Content-Length: ' . filesize($con[backfilepath] . $filename));
    readfile($con[backfilepath] . $filename);
    exit;
  }
}

$ConfigInfo = array();
if ($validate_err > 0) {
	$ConfigInfo["module"]["loglevel"] = htmlspecialchars(trim($_POST['txt_loglevel']), ENT_QUOTES, 'UTF-8');;
} else {
  $ConfigInfo["module"] = array(
    "loglevel" => getArrayIndex(ConfigRead("module/loglevel"),0)
  );
}
$ConfigInfo["module"]["lognumfiles"] = getArrayIndex(ConfigRead("module/lognumfiles"),0);
?>
<html>
<head>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache"/>
<META HTTP-EQUIV="Expires" CONTENT="-1"/>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" media="screen" href="../css/styles.css" />
    <script src="/scripts/angular.min.js" type="text/JavaScript"></script>
    <script src="/scripts/jquery.min.js" type="text/JavaScript"></script>
    <script src="/js/application.js" type="text/JavaScript"></script>
    <script src="/js/main.js" type="text/JavaScript"></script>
<?php /* <!-- initialize --> */ ?>
<style type="text/css">
<!--
.STYLE2 {
font-size: 12px;
color: #006699
}
-->
</style>
</head>
<body leftmargin="0" topmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" onload='parent.resizeIframe(document.body.scrollHeight)'>
<?php /* <!-- Start Body --> */ ?>
<table width=100% height="580" cellpadding="0" cellspacing="0" >
  <tr height=13 >
    <td width=14 ><img src="/images/leftopangle.jpg" /></td>
    <td background="/images/bgtop.jpg" ></td>
    <td width=14 ><img src="/images/rightopangle.jpg" /></td>
  </tr>
  <tr>
    <td background="/images/bgleft.jpg" >&nbsp;</td>
    <td align="center" valign="top">
<?php /* <!--Start content here --> */ ?>
      <table width="98%" border="0" cellspacing="0" cellpadding="0" bgcolor="#002569">
        <tr>
          <td width="100%" bgcolor="#FFFFFF"><table width="100%" border="0" cellspacing="0" cellpadding="0">
            <tr> <td width="75%"/> </tr>
<?php if ($validate_err > 0) {
  echo "<h3 style='color:#f04040'>The parameters highlighted in red are incorrect.  Please update with a valid value.</h3>";
} ?>
          </table>
<?php /* <!-- Body starts here --> */ ?>
          <table width="100%" border="0" cellspacing="0" cellpadding="0">
            <tr> <td valign="top" class="subhead">
              <form action="administrator_logs.php?action=1" name="formLogs" id="formLogs" method="post" >
              <input type="hidden" name="csrf" value="<?php echo $_SESSION['csrf']; ?>" />
                <table width="100%" border="0" cellpadding="0" cellspacing="0">
                  <tr class="tablehead"> <td colspan="2">System Logs</td> </tr>
                  <tr> <td height="4" colspan="2" align="left" bgcolor="#4d92a8"></td> </tr>
                  <tr class="row"> <td>
                    System Log Level (1-8)&nbsp;
                    <input type="text" class="copy" name="txt_loglevel" id="txt_loglevel" value="<?php echo $ConfigInfo["module"]["loglevel"]; ?>" size="2" maxlength="1"/>
                    &nbsp;<input type="button" class="copy" name="btn_llevel_apply" id="btn_llevel_apply" value="Apply" onClick="AdmLogValidateLLevel();"/>
                  </td> </tr>
                  <tr class="row"> <td valign="middle">
                    <input type="button"  class="copy" name="btn_logrefresh" id="btn_logrefresh"  value="<?php if ($show == 1) {echo "Show Recent Log Entries";} else {echo "Refresh";}?>" onClick="AdmLogRefreshLogFile();"/>
                    &nbsp;<input type="button" class="copy" name="btn_showarchfile" id="btn_showarchfile" onClick="AdmLogShowArchFile();" value="<?php if ($show == 1) {echo "Refresh";} else {echo "Show";}?> all log entries"/>
                    &nbsp;<input type="button"  class="copy" name="btn_logsave" id="btn_logsave" onClick="AdmLogSaveLogFile(<?php echo $show; ?>);" value="Download"/>
		    &nbsp;<input type="button"  class="copy" name="btn_logclear" id="btn_logclear" value="<?php if ($show == 4) {echo "Clear log entries";} else {echo "Clear Logs";}?>" onClick="AdmLogClear();"/>
                </table>
              </form>
            </td> </tr>
            <tr> <td valign="top" colspan="1" align="left"><pre>
              <?php
                  if ($show) {
                      for ($i = $ConfigInfo["module"]["lognumfiles"]; $i > -1; $i--) {
                          echo htmlspecialchars(file_get_contents("/var/log/messages." . $i));
                      }
                  }
                  echo htmlspecialchars(file_get_contents("/tmp/messages"));
              ?>
              </pre></td> </tr>
          </table> </td>
        </tr>
      </table>
<?php /* <!--End content here --> */ ?>
    </td>
    <td background="/images/bgright.jpg">&nbsp;</td>
  </tr>
  <tr height=16>
    <td ><img src="/images/leftbtmangle.jpg" /></td>
    <td background="/images/bgbtm.jpg"></td>
    <td ><img src="/images/rightbtmangle.jpg" /></td>
  </tr>
</table>
<?php /* <!--End body --> */ ?>
<script>
<?php /* //Set the top menu style */ ?>
window.parent.document.getElementById("leftlink_administrator_system").className = "leftNavLink";
window.parent.document.getElementById("leftlink_administrator_access").className = "leftNavLink";
window.parent.document.getElementById("leftlink_administrator_logs").className = "leftNavLinkActive";
window.parent.document.getElementById("leftlink_administrator_sms").className = "leftNavLink";
window.parent.document.getElementById("leftlink_administrator_ping").className = "leftNavLink";
var errcnt = <?php echo $validate_err;?>;
var errarray<?php
if ($validate_err > 0) {
  echo '=[';
}
for ($i=0; $i<$validate_err; $i++) {
  if ($i != 0 ) {
    echo ',';
  }
  echo "\"$errArray[$i]\"";
}
if ($validate_err > 0) {
  echo ']';
}

?>;
HighlightValidationErrors(errcnt, errarray);
</SCRIPT>
</body>
</html>
