<?php
session_start();
require_once('../inc/userfunction.php');
require_once('../inc/systemfunction.php');

// Check the login session
if (CheckUserSession() == false) {
    header("Location: /components/session_expired.php");
    exit;
}

$method = $_SERVER['REQUEST_METHOD'];
$csrf = $_POST['csrf'];

// Check the CSRF token
if (CheckCSRFToken($method, $csrf) == false) {
	error_log("Warning! Possible CSRF detected.", 0);
	exit;
}

$validate_err = 0;

$txt_PingIP=htmlspecialchars(trim($_POST['txt_PingIP']), ENT_QUOTES, 'UTF-8');
$action=$_REQUEST['action'];

if ($action == 1)
{
  $ValidIpv4AddressRegex = "/^(([01]?[0-9]?[0-9]|2([0-4][0-9]|5[0-5]))\.){3}([01]?[0-9]?[0-9]|2([0-4][0-9]|5[0-5]))$/";
  $ValidHostnameRegex = "/^([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])(\.([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]{0,61}[a-zA-Z0-9]))*$/";

  if (((0 == preg_match($ValidIpv4AddressRegex,$txt_PingIP)) &&
       (0 == preg_match($ValidHostnameRegex,$txt_PingIP))) ||
       (strlen($txt_PingIP) > 50) || (strlen($txt_PingIP) == 0)) {
    $errArray[$validate_err++] = "txt_PingIP";
  } else {
    $txt_PingTimes = 4;
    $straPingMessage = ShowPingMessage($txt_PingIP,$txt_PingTimes);
    $PingMessage = implode("\n",$straPingMessage);
  }
}

?>
<html>
<head>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache"/>
<META HTTP-EQUIV="Expires" CONTENT="-1"/>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" media="screen" href="../css/styles.css" />
    <script src="/scripts/angular.min.js" type="text/JavaScript"></script>
    <script src="/scripts/jquery.min.js" type="text/JavaScript"></script>
    <script src="/js/application.js" type="text/JavaScript"></script>
    <script src="/js/main.js" type="text/JavaScript"></script>
<?php /* <!-- initialize --> */ ?>
</head>
<body leftmargin="0" topmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" >
<?php /* <!-- Start Body --> */ ?>
<table width=100% height="580" cellpadding="0" cellspacing="0" >
  <tr height=13 >
    <td width=14 ><img src="/images/leftopangle.jpg" /></td>
    <td background="/images/bgtop.jpg" ></td>
    <td width=14 ><img src="/images/rightopangle.jpg" /></td>
  </tr>
  <tr>
    <td background="/images/bgleft.jpg" >&nbsp;</td>
    <td align="center" valign="top">
<?php /* <!--Start content here --> */ ?>
      <table width="98%" border="0" cellspacing="0" cellpadding="0" bgcolor="#002569">
        <tr>
          <td width="100%" bgcolor="#FFFFFF"><table width="100%" border="0" cellspacing="0" cellpadding="0">
            <tr><td width="75%"></td></tr>
          </table>
<?php /* <!-- Body starts here --> */ ?>
          <table width="100%" border="0" cellspacing="0" cellpadding="0">
            <tr>
              <td valign="top" class="subhead">
                <form action="administrator_ping.php?action=1" method="POST" name="systemping"  id="systemping" >
                <input type="hidden" name="csrf" value="<?php echo $_SESSION['csrf']; ?>" />
                  <table width="100%" border="0" cellpadding="4" cellspacing="0">
                    <tr class="tablehead"><td colspan="3">System Ping </td></tr>
                    <tr><td height="4" colspan="3" align="left" bgcolor="#4d92a8"></td></tr>
                    <tr class="row">
                      <td >&nbsp;</td>
                      <td valign="middle">&nbsp;</td>
                      <td align="left" valign="middle">&nbsp;</td>
                    </tr>
                    <tr  class="inputcol">
                      <td width="268" >
                        <input name="txt_PingIP" type="text" class="copy" id="txt_PingIP" value="<?php echo $txt_PingIP ?>" size="40" maxlength="512"/>
                      </td>
                      <td width="98" ><input type="submit"  class="copy" name="showping" id="showping" value="Ping" style="width:55px"></td>
                      <td width="872" align="left" valign="middle"><div id="loading" style="display:none;">
                      <table width="100%" border="0" cellspacing="0" cellpadding="0">
                        <tr height="30">
                          <td width="5%">&nbsp;</td>
                          <td ><img src="/images/progressbar_red.gif" width="100" height="9"></td>
                          <td >&nbsp;</td>
                        </tr>
                      </table>
                      </div></td>
                    </tr>
                  </table>
                </form>
              </td>
            </tr>
            <tr>
              <td valign="top" >
<?php /* <!--  jtable div --> */ ?>
                <div id="dynamic">
                  <textarea name="textareapingmsg" id="textareapingmsg" cols="120" rows="25" readonly ><?php
                  echo $PingMessage ;
                  ?>
                  </textarea>
                </div>
              </td>
            </tr>
          </table></td>
        </tr>
      </table>
<?php /* <!--End content here --> */ ?>
    </td>
    <td background="/images/bgright.jpg">&nbsp;</td>
  </tr>
  <tr height=16>
    <td ><img src="/images/leftbtmangle.jpg" /></td>
    <td background="/images/bgbtm.jpg"></td>
    <td ><img src="/images/rightbtmangle.jpg" /></td>
  </tr>
</table>
<?php /* <!--End body -->*/ ?>
<script>
<?php /* //Set the top menu style */ ?>
window.parent.document.getElementById("leftlink_administrator_system").className = "leftNavLink";
window.parent.document.getElementById("leftlink_administrator_access").className = "leftNavLink";
window.parent.document.getElementById("leftlink_administrator_logs").className = "leftNavLink";
window.parent.document.getElementById("leftlink_administrator_sms").className = "leftNavLink";
window.parent.document.getElementById("leftlink_administrator_ping").className = "leftNavLinkActive";
var errcnt = <?php echo $validate_err;?>;
var errarray<?php
if ($validate_err > 0) {
  echo '=[';
}
for ($i=0; $i<$validate_err; $i++) {
  if ($i != 0 ) {
    echo ',';
  }
  echo "\"$errArray[$i]\"";
}
if ($validate_err > 0) {
  echo ']';
}
?>;
HighlightValidationErrors(errcnt, errarray);
</SCRIPT>
</body>
</html>
