<?php
    session_start();
    require_once('../inc/userfunction.php');
    require_once('../inc/filefunction.php');
    require_once('../inc/uploadclass.php');
    require_once('../inc/config.inc.php');
    require_once('../inc/common_functions.php');
    require_once('../inc/systemfunction.php');

    // Check the login session
    if (CheckUserSession() == false) {
        header("Location: /components/session_expired.php");
        exit;
    }

    $method = $_SERVER['REQUEST_METHOD'];
    $csrf = $_POST['csrf'];

    // Check the CSRF token
    if (CheckCSRFToken($method, $csrf) == false) {
    	error_log("Warning! Possible CSRF detected.", 0);
    	exit;
    }

    $validate_err = 0;
    $action = $_REQUEST['action'];

    // Get upload and restore fields for check
    if ($action == "backup") {
        $filename = "/psft/etc/icx35.cfg";
        if (file_exists($filename)) {
            header('Content-Description: File Transfer');
            header('Content-Type: application/octet-stream');
            header('Content-Disposition: attachment; filename=icx35.cfg');
            header('Expires: 0');
            header('Cache-Control: must-revalidate');
            header('Pragma: public');
            header('Content-Length: ' . filesize($filename));
            readfile($filename);
            exit;
        }
    } else if ($action == "uploadrestore") {
        $upload_file=basename($_FILES['file_restore']['name']);
        $upload_file_ext = end((explode(".", $upload_file)));

        if($upload_file) {
            global $con;
            $icxconfigfolder= $con[icxconfigfolder];
            $icxconfigfile=$con[icxconfigfile];
            
            if (isset($_FILES["file_restore"])) {
                /* Filter the file types */
                if (($_FILES["file_restore"]["error"] > 0) || 
                   (0 != strcasecmp($upload_file_ext, "cfg") ) ) {
                    //  echo "Error: " . $_FILES["file_restore"]["error"] . "<br>";
                   $errMsgs[$validate_err] = "Please select a .cfg file";
                   $errArray[$validate_err++] = "file_restore";
                } else {
                    /* Copy current file to backup */
                    if (file_exists($icxconfigfolder.$icxconfigfile)) {
                        copy($icxconfigfolder.$icxconfigfile,$icxconfigfolder."icx35backup.cfg");
                    }
                    /* Move the uploaded file to uploads folder */
                    move_uploaded_file($_FILES["file_restore"]["tmp_name"],$icxconfigfolder.$icxconfigfile);
                    echo "Uploaded File :".$_FILES["file_restore"]["name"];
                    exec("/usr/bin/dos2unix " . $icxconfigfolder . $icxconfigfile, $statval);
                    ///RebootModule();
                    echo "<script>window.location = 'rebooting.php';</script>";
                    exit(0);
                }
            }
        } else {
            /* Error - No File */
            $errMsgs[$validate_err] = "No configuration file selected.";
            $errArray[$validate_err++] = "file_restore";
        }
    } else if ($action == "reset") {
        ResetToDefault();
    } else if ($action == "reboot") {
        echo "<script>window.location = 'rebooting.php?action=reboot';</script>";
        exit(0);
    } else if ($action == "upload") {
        $upload_file=basename($_FILES['upload_file']['name']);
        if($upload_file) {
            $output_dir = "/psft/";
            $icx35fwname = "icx35fwimage.img";
        
            if(isset($_FILES["upload_file"])) {
                /* Filter the file types , if you want */
                if ($_FILES["upload_file"]["error"] > 0) {
                    echo "Error: " . $_FILES["file"]["error"] . "<br>";
                } else {
                    /* move the uploaded file to uploads folder */
                   move_uploaded_file($_FILES["upload_file"]["tmp_name"],
                   $output_dir. $icx35fwname);
                   //echo "Uploaded File :".$_FILES["upload_file"]["name"];
                   echo "<script>window.location = 'rebooting.php?action=FW';</script>";
                   ///RebootModule();
                   exit(0);
                }
            }
        } else {
            /* Error - No File */
            $errMsgs[$validate_err] = "No firmware image selected.";
            $errArray[$validate_err++] = "upload_file";
        }
    } else if ($action == "upload_radio") {
        $upload_file_radio=basename($_FILES['upload_file_radio']['name']);
        $upload_file_radio_path=$_FILES["upload_file_radio"]["tmp_name"];
        $upload_file_radio_ext = end((explode(".", $upload_file_radio)));
        if ($upload_file_radio) {
            $output_dir = "/psft/radiofw/";
        
            if (isset($_FILES["upload_file_radio"])) {
                exec("/psft/scripts/spk_validate.sh $upload_file_radio_path",$spk_validation);
                exec("/psft/bin/cellCmdRequest ATI", $radio_model);
                if (($_FILES["upload_file_radio"]["error"] > 0) || 
                    (0 != strcasecmp($upload_file_radio_ext, "spk"))) {
                    echo "Error: " . $_FILES["file"]["error"] . "<br>";
                    $errMsgs[$validate_err] = "Please select a .spk file";
                    $errArray[$validate_err++] = "upload_file_radio";
                } else if ((FALSE !== stripos($radio_model[4], "MC7304")) &&
                           (FALSE !== stripos($upload_file_radio, "VZW"))) {
                    echo "Error: " . $_FILES["file"]["error"] . "<br>";
                    $errMsgs[$validate_err] = "$upload_file_radio image is invalid (Verizon only)!!!";
                    $errArray[$validate_err++] = "upload_file_radio";
                } else if (0 != strcasecmp("$spk_validation[0]","valid")) {
                    echo "Error: " . $_FILES["file"]["error"] . "<br>";
                    $errMsgs[$validate_err] = "$upload_file_radio image is invalid!!!";
                    $errArray[$validate_err++] = "upload_file_radio";
                } else {
                    //move the uploaded file to uploads folder;
                    move_uploaded_file($_FILES["upload_file_radio"]["tmp_name"], $output_dir.$upload_file_radio);
                    //echo "Uploaded File :".$_FILES["upload_file"]["name"];
                    exec("/bin/sync");
                    // Calculate md5 hash of spk file
                    $md5file = md5_file($output_dir.$upload_file_radio);
                    file_put_contents($output_dir."md5file.txt",$md5file."  ".$output_dir.$upload_file_radio);
                    echo "<script>window.location = 'rebooting.php?action=FW_radio';</script>";
                    ///RebootModule();
                    exit(0);
                }
            }
        } else {
            //Error - No File
            $errMsgs[$validate_err] = "No Radio file selected";
            $errArray[$validate_err++] = "upload_file_radio";
        }
    }

?>
<html>
    <head>
        <meta http-equiv="Cache-Control" content="no-cache, must-revalidate">
        <meta http-equiv="Pragma" content="no-cache">
        <meta http-equiv="Expires" content="0">
        <link rel="stylesheet" href="/css/styles.css" type="text/css" />
            <script src="/scripts/jquery.min.js" type="text/JavaScript"></script>  
            <script src="/scripts/angular.min.js" type="text/JavaScript"></script> 
            <script src="/scripts/bootstrap.min.js" type="text/JavaScript"></script> 
            <script src="/js/application.js" type="text/JavaScript"></script> 
            <script src="/js/main.js" type="text/JavaScript"></script>
        <style type="text/css">
            .animate-show {
                line-height: 20px;
                opacity: 1;
                padding: 10px;
                border: 0px solid black;
                background: white;
            }

            .animate-show.ng-hide-add, .animate-show.ng-hide-remove {
                transition: all linear 0.5s;
            }

            .animate-show.ng-hide {
                line-height: 0;
                opacity: 0;
                padding: 0 10px;
            }   
        </style>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    </head>
    <body leftmargin="0" topmargin="0" rightmargin="0" ng-app="LightDocs" bottommargin="0" marginwidth="0" onload='parent.resizeIframe(document.body.scrollHeight)'>
        <?php /* <!-- Start Body --> */ ?>
        <table width=100% height="550" cellpadding="0" cellspacing="0" ng-controller="CloudCtrl" data-ng-init="loadPageData()" ng-cloak>
            <tr height=13 >
                <td width=14 ><img src="/images/leftopangle.jpg" /></td>
                <td background="/images/bgtop.jpg" ></td>
                <td width=14 ><img src="/images/rightopangle.jpg" /></td>
            </tr>
            <tr>
                <td background="/images/bgleft.jpg" >&nbsp;</td>
                <td align="center" valign="top">
                <?php /* <!--Start content here --> */ ?>
                <table width="98%" border="0" cellspacing="0" cellpadding="0" bgcolor="#002569">
                    <tr>
                        <td width="100%" bgcolor="#FFFFFF">
                            <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                <tr>
                                    <td width="75%"></td>
                                </tr>
                            </table>
                            <?php /* <!-- Body starts here --> */ ?>
                            <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                <tr>
                                    <td valign="top" class="subhead">
                                        <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                            <tr>
                                                <td width="46%"></td>
                                            </tr>
                                        </table>
                                    </td>
                                </tr>
                                <tr>
                                    <td valign="top" class="subhead">
                                        <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                            <tr>
                                                <td>
                                                    <?php
                                                        if ($validate_err > 0) {
                                                            echo "<h3 style='color:#f04040'>The parameters highlighted in red are incorrect.  Please update with a valid value.</h3>";
                                                            for ($i=0; $i < $validate_err; $i++) {
                                                                echo "<h4 style='color:#f04040'>" .$errMsgs[$i] . "</h4>";
                                                            }
                                                        }
                                                    ?>
                                                    <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                        <tr>
                                                            <td>
                                                                <table width="100%" height="30" border="0" cellpadding="0" cellspacing="0">

                                                                    <?php /* <!-- Reboot Unit start --> */ ?>
                                                                    <tr class="tablehead">
                                                                        <td colspan="3">Reboot Unit</td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td height="4" colspan="3" align="left" bgcolor="#4d92a8"></td>
                                                                    </tr>
                                                                    <tr class="sorttable">
                                                                        <form action="administrator_system.php?action=reboot" name="form_reboot" id="form_reboot" method="POST">
                                                                          <input type="hidden" name="csrf" value="<?php echo $_SESSION['csrf']; ?>" />
                                                                            <td colspan="3">
                                                                                <input name="reboot" type="button" class="copy" id="reboot" value="Reboot" onClick="AdmSysReboot();" style="width:60px"/>
                                                                            </td>
                                                                        </form>
                                                                    </tr>
                                                                    <tr>
                                                                        <td colspan="3" height="30">&nbsp;</td>
                                                                    </tr>

                                                                    <?php /* <!-- Configuration Backup --> */ ?>
                                                                    <tr class="tablehead">
                                                                        <td colspan="3">Configuration Backup</td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td height="4" colspan="3" align="left" bgcolor="#4d92a8"></td>
                                                                    </tr>
                                                                    <tr class="sorttable">
                                                                        <form action="administrator_system.php?action=backup" name="form_backup" id="form_backup" method="POST">
                                                                          <input type="hidden" name="csrf" value="<?php echo $_SESSION['csrf']; ?>" />
                                                                            <td colspan="3">
                                                                                <input name="backup" type="button" class="copy" id="backup" value="Backup" onClick="AdmSysSaveBackUpFile();" style="width:60px"/>
                                                                            </td>
                                                                        </form>
                                                                    </tr>
                                                                    <tr class="tablehead">
                                                                        <td colspan="3" height="30">&nbsp;</td>
                                                                    </tr>

                                                                    <?php /* <!-- Configuration Restore --> */ ?>
                                                                    <tr class="tablehead">
                                                                        <td colspan="3">Configuration Restore</td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td height="4" colspan="3" align="left" bgcolor="#4d92a8"></td>
                                                                    </tr>
                                                                    <tr class="sorttable">
                                                                        <form action="administrator_system.php?action=uploadrestore" enctype="multipart/form-data" name="form_restore" id="form_restore" method="POST">
                                                                          <input type="hidden" name="csrf" value="<?php echo $_SESSION['csrf']; ?>" />
                                                                            <td width="120">Please select file </td>
                                                                            <td width="210">
                                                                                <input name="file_restore" type="file"  id="file_restore" accept=".cfg" class="copy" size="30" style="width:210px"/>
                                                                            </td>
                                                                            <td>
                                                                                <input name="btn_restore" type="button" class="copy" id="btn_restore" value="Restore" onClick="AdmSysStartRestore();" style="width:70px"/>
                                                                            </td>
                                                                        </form>
                                                                    </tr>
                                                                    <tr>
                                                                        <td colspan="3" height="30">&nbsp;</td>
                                                                    </tr>

                                                                    <?php /* <!-- Reset Unit to Default Configuration --> */ ?>
                                                                    <tr class="tablehead">
                                                                        <td colspan="3">Reset Unit to Default Configuration</td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td height="4" colspan="3" align="left" bgcolor="#4d92a8"></td>
                                                                    </tr>
                                                                    <tr class="sorttable">
                                                                        <td colspan="3">
                                                                            <input name="backup" type="button" class="copy" id="backup" onClick="AdmSysStartReset();" value="Reset" style="width:60px"/>
                                                                        </td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td colspan="3" height="30">&nbsp;</td>
                                                                    </tr>

                                                                    <?php /* <!-- Firmware Upgrade --> */ ?>
                                                                    <tr class="tablehead">
                                                                        <td colspan="3">Firmware Upgrade</td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td colspan="3" height="4" align="left" bgcolor="#4d92a8"></td>
                                                                    </tr>
                                                                    <tr class="sorttable">
                                                                        <td colspan="3">
                                                                            <form id="form_upload" action="administrator_system.php?action=upload" enctype="multipart/form-data" name="form_upload" onsubmit="return AdmSysStartUpload();" method="POST">
                                                                              <input type="hidden" name="csrf" value="<?php echo $_SESSION['csrf']; ?>" />
                                                                                <table width="100%" height="30" border="0" cellpadding="0" cellspacing="0">
                                                                                    <tr>
                                                                                        <td width="120">Please select file </td>
                                                                                        <td width="210">
                                                                                            <input type="file" size="30" name="upload_file" id="upload_file" accept=".img" class="copy" style="width:210px">
                                                                                        </td>
                                                                                        <td>
                                                                                            <input type="submit" value="Upgrade" class="copy" style="width:70px"/>
                                                                                        </td>
                                                                                    </tr>
                                                                                </table>
                                                                            </form>
                                                                            <div id="progress" style="display:none" ><img src="../images/working.gif"/></div>
                                                                        </td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td colspan="3" height="30">&nbsp;</td>
                                                                    </tr>
                                                                    <?php /* <!-- Internal Radio Software --> */ ?>
                                                                    <tr class="tablehead">
                                                                        <td colspan="3">Internal Radio Software</td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td colspan="3" height="4" align="left" bgcolor="#4d92a8"></td>
                                                                    </tr>
                                                                    <tr class="sorttable">
                                                                        <td colspan="3">
                                                                            <form id="form_upload_radio" action="administrator_system.php?action=upload_radio" enctype="multipart/form-data" name="form_upload_radio" onsubmit="return AdmSysStartUploadRadio();" method="POST">
                                                                              <input type="hidden" name="csrf" value="<?php echo $_SESSION['csrf']; ?>" />
                                                                                <table width="100%" height="30" border="0" cellpadding="0" cellspacing="0">
                                                                                    <tr>
                                                                                        <td width="120">Please select file </td>
                                                                                        <td width="210">
                                                                                            <input type="file" size="30" name="upload_file_radio" id="upload_file_radio" accept=".spk" class="copy" style="width:210px">
                                                                                        </td>
                                                                                        <td>
                                                                                            <input type="submit" value="Upgrade Radio" class="copy" style="width:100px"/>
                                                                                        </td>
                                                                                    </tr>
                                                                                </table>
                                                                            </form>
                                                                            <div id="progress_radio" style="display:none" ><img src="../images/working.gif"/></div>
                                                                        </td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td colspan="3" height="30">&nbsp;</td>
                                                                    </tr>

                                                                    <?php /* <!-- ProSoft Connect --> */ ?>
                                                                    <tr class="tablehead">
                                                                        <td colspan="3">ProSoft Connect</td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td colspan="3" height="4" align="left" bgcolor="#4d92a8"></td>
                                                                    </tr>
                                                                    <tr class="sorttable">
                                                                        <td colspan="3">
                                                                            <div style="width:100%;height:100%;" ng-show="!waitForDataLoad" >
                                                                                <table  border="0">
                                                                                    <tr>
                                                                                        <td>
                                                                                            <div class="connectStatus" name="connectStatus" ng-show="!showActivationPanel" >
                                                                                                <table>
                                                                                                    <tr>
                                                                                                        <td width="120">ProSoft Connect </td>
                                                                                                        <td width="150">
                                                                                                            <button id="button_connect_device"  class="copy" style="width: 110px; height: 20px;" ng-click="connectToCloud()">{{connectionStatusString}}</button>
                                                                                                        </td>
                                                                                                    </tr>
                                                                                                </table>
                                                                                            </div>
                                                                                        </td>
                                                                                    </tr>
                                                                                    <tr>
                                                                                        <td>
                                                                                            <div name="activationStatus" class="animate-show"  ng-show="showActivationPanel" >
                                                                                                <table border="0" cellpadding="0" cellspacing="0">
                                                                                                    <tr>
                                                                                                        <td width="120">ProSoft Connect </td>
                                                                                                        <td width="150">
                                                                                                            <button id="button_activate_device" class="copy" style="width: 110px; height: 20px;"  ng-click="cancelActivation()">Activating</button>
                                                                                                        </td>
                                                                                                        <td valign="top">
                                                                                                            <div class="animate-show" ng-show="isActivatingBool">
                                                                                                                <b>
                                                                                                                    <label size="30" id="cloud_key_status" class="copy" style="width:210px">{{settings.Activation.key}}</label>
                                                                                                                </b>
                                                                                                            </div>
                                                                                                        </td>
                                                                                                    </tr>
                                                                                                    <tr>
                                                                                                        <td colspan="3"> 
                                                                                                            <label size="30" id="cloud_connected_status" class="copy">
                                                                                                                Note: Log into
                                                                                                                <a name="prosoft_connect_link" href="https://www.prosoft.io/" target="_blank">www.prosoft.io</a>
                                                                                                                , click "Activate Gateway" and enter the code
                                                                                                            </label>                                         
                                                                                                        </td>
                                                                                                    </tr>
                                                                                                </table>
                                                                                            </div>
                                                                                        </td>
                                                                                    </tr>
                                                                                    <tr>
                                                                                        <td colspan="3" style="padding: 10px 0; color: red;">
                                                                                            <label size="30" id="cloud_error_status" class="copy" ng-show="loggingBool">{{errorMessage}}</label>
                                                                                        </td>
                                                                                    </tr>
                                                                                </table>
                                                                            </div>
                                                                            <div style="padding: 10px 0;" ng-show="waitForDataLoad">
                                                                                Checking Cloud connection status...
                                                                            </div>
                                                                        </td>
                                                                    </tr>
                                                                </table>
                                                            </td>
                                                        </tr>
                                                    </table>
                                                </td>
                                            </tr>
                                        </table>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </table>
                <?php /* <!--End content here --> */ ?>
            </td>
            <td background="/images/bgright.jpg">&nbsp;</td>
            </tr>
            <tr height=16>
                <td ><img src="/images/leftbtmangle.jpg" /></td>
                <td background="/images/bgbtm.jpg"></td>
                <td ><img src="/images/rightbtmangle.jpg" /></td>
            </tr>
        </table>
        <?php /* <!--End body -->*/ ?>
        <script>
            <?php //Set the top menu style ?>
            window.parent.document.getElementById("leftlink_administrator_system").className = "leftNavLinkActive";
            window.parent.document.getElementById("leftlink_administrator_access").className = "leftNavLink";
            window.parent.document.getElementById("leftlink_administrator_logs").className = "leftNavLink";
            window.parent.document.getElementById("leftlink_administrator_sms").className = "leftNavLink";
            window.parent.document.getElementById("leftlink_administrator_ping").className = "leftNavLink";
            var errcnt = <?php echo $validate_err;?>;
            var errarray<?php
                if ($validate_err > 0) {
                    echo '=[';
                }
                for ($i=0; $i<$validate_err; $i++) {
                    if ($i != 0 ) {
                        echo ',';
                    }
                    echo "\"$errArray[$i]\"";
                }
                if ($validate_err > 0) {
                    echo ']';
                }

            ?>;
            HighlightValidationErrors(errcnt, errarray);
        </script>
    </body>
</html>
