<?php
session_start();
require_once('../inc/userfunction.php');
require_once('../inc/systemfunction.php');

// Check the login session
if (CheckUserSession() == false) {
    header("Location: /components/session_expired.php");
    exit;
}

$method = $_SERVER['REQUEST_METHOD'];
$csrf = $_POST['csrf'];

// Check the CSRF token
if (CheckCSRFToken($method, $csrf) == false) {
	error_log("Warning! Possible CSRF detected.", 0);
	exit;
}

?>
<html>
    <head lang="en">
        <meta charset="utf-8">
        <title>Custom Plunker</title>  
        <link rel="stylesheet" href="/css/styles.css" type="text/css"/>
        <link rel="styleSheet" href="/content/ng-grid.min.css"/>
        <link rel="styleSheet" href="/content/bootstrap.min.css"/>
        <link rel="styleSheet" href="/content/bootstrap-theme.min.css"/>
        <script src="/scripts/jquery.min.js" type="text/JavaScript"></script>  
        <script src="/scripts/angular.min.js" type="text/JavaScript"></script> 
        <script src="/scripts/ng-grid.min.js" type="text/JavaScript"></script>
        <script src="/scripts/bootstrap.min.js" type="text/JavaScript"></script> 
        <script src="/js/forwardingApplication.js" type="text/JavaScript"></script>
        <script src="/js/main.js" type="text/JavaScript"></script>
    </head>
    <body ng-app="FirewallApplication" leftmargin="0" topmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" onload='parent.resizeIframe(document.body.scrollHeight)'>
<?php /* <!-- Start Body --> */ ?>
<table ng-controller="FirewallController" width=100% height="550" cellpadding="0" cellspacing="0" data-ng-init="loadData()" ng-cloak>
    <tr height=13>
        <td width=14 ><img src="/images/leftopangle.jpg" /></td>
        <td background="/images/bgtop.jpg" ></td>
        <td width=14 ><img src="/images/rightopangle.jpg" /></td>
    </tr>
    <tr>
        <td background="/images/bgleft.jpg" >&nbsp;</td>
        <td align="center" valign="top">
            <table width="98%" border="0" cellspacing="0" cellpadding="0" <?php /*bgcolor="#002569"*/ ?>>
                <tr>
                    <td width="100%" <?php /*bgcolor="#FFFFFF"*/ ?>>
                        <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tr> <td width="75%"> </td> </tr>
                        </table>
                        <table width="100%" border="0" cellspacing="0" cellpadding="0">
                            <tr>
                                <td valign="top">
                                    <table width="98%" border="0" cellspacing="0" cellpadding="0" bgcolor="#002569">
                                        <tr>
                                            <td>
                                                <table width="100%" border="0" cellpadding="4" cellspacing="0">
                                                    <tr>
                                                        <td valign="top">
                                                            <table width="100%" border="0" cellpadding="4" cellspacing="0">
                                                                <tr class="tablehead">
                                                                    <td colspan="2" id="tdPTTitle">
                                                                        <a style="cursor:pointer;">Pass Through</a>
                                                                    </td>
                                                                </tr>
                                                                <tr>
                                                                    <td height="4" colspan="4" align="left" bgcolor="#4d92a8"></td>
                                                                </tr> 
                                                            </table>
                                                            <div id="divPTConfig" style="display:block;">
                                                                <table data-ng-init="loadData()" width="100%" border="0" cellpadding="4" cellspacing="0">
                                                                    <tr class="sorttable">
                                                                        <td width="241">Enable</td>
                                                                        <td colspan="2" class="inputcol">
                                                                            <select name="passThroughStatus" class="inputcol" style="width: 100px;" 
                                                                                                        ng-change="selectPTStatus()"         
                                                                                                        ng-model="passThroughStatusList.defaultId" 
                                                                                                        ng-options="passThroughStatus.passThroughStatusId as passThroughStatus.name for passThroughStatus in passThroughStatusList"
                                                                                                        required> 
                                                                            </select> 
                                                                        </td>
                                                                    </tr>
                                                                        <form name="ptForm" ng-submit="submitPTForm()" novalidate>
                                                                            <input type="hidden" name="csrf" value="<?php echo $_SESSION['csrf']; ?>" />
                                                                            <tr class="sorttablenobg">
                                                                                <td td colspan="3" class="inputcol">
                                                                                    <div class="form-group" style="font-size:11px; font-weight:bold;" ng-class="{ 'has-error' : ptForm.endDeviceAddr.$invalid }">
                                                                                        <p ng-show="ptForm.endDeviceAddr.$error.required" class="help-block" style="color:#f04040">Error: please complete the End Device IP address.</p>
                                                                                        <p ng-show="ptForm.endDeviceAddr.$error.minlength" class="help-block" style="color:#f04040">Error: the IP address is too short.</p>
                                                                                        <p ng-show="ptForm.endDeviceAddr.$error.maxlength" class="help-block" style="color:#f04040">Error: the IP address is too long.</p> 
                                                                                        <p ng-show="ptForm.endDeviceAddr.$error.pattern"  class="help-block" style="color:#f04040">Error: invalid IP address format.</p>
                                                                                    </div>
                                                                                    <div class="form-group" style="color:#f04040; font-size:11px; font-weight:bold;" ng-class="{ 'has-error' : fwForm.$invalid }">
                                                                                        <p class="help-block" ng-show="!ptFormValid" style="color:#f04040">Error: {{ptWarningMessage}}</p>   
                                                                                        <p class="help-block" ng-show="!loggingBool" style="color:#f04040">Error: {{ptWarningMessage}}</p>
                                                                                    </div>
                                                                                </td>
                                                                            </tr>
                                                                            <tr class="sorttable">
                                                                                <td width="241">End Device Address</td>
                                                                                <td colspan="2" class="inputcol">    
                                                                                    <div style="display: flex; width: 145px; vertical-align: middle; text-align: center;">
                                                                                        <input name="endDeviceAddr" class="inputcol" style="width: 130px;" 
                                                                                            ng-model="endDeviceAddr" 
                                                                                            ng-minlength="1" 
                                                                                            ng-maxlength="15" 
                                                                                            required ng-pattern="/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/"> 
                                                                                    </div>
                                                                                </td>
                                                                            </tr>
                                                                        </form>
                                                                </table>
                                                            </div>
                                                        </td>
                                                    </tr>
                                                </table>
                                            </td>
                                        </tr> 
                                        <tr>
                                            <td width="100%" bgcolor="#FFFFFF">
                                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                    <tr>
                                                        <td width="75%"></td>
                                                    </tr>
                                                    <tr class="tablehead">
                                                        <td colspan="2" id="tdPortFWTitle">
                                                            <a style="cursor:pointer;">Port Forwarding</a>
                                                        </td>
                                                    </tr>
                                                </table>
                                                <div id="divPortFWHelp" style="display:block;">
                                                    <table width="100%" border="0" cellpadding="4" cellspacing="0">
                                                        <tr>
                                                            <td height="4" colspan="4" align="left" bgcolor="#4d92a8"></td>
                                                        </tr> 
                                                        <tr class="sorttable">
                                                            <td style="width:30%;"><b>Common Ports: </b></td>
                                                            <td style="width:70%;"><b>Example: </b></td>
                                                        </tr>
                                                        <tr>
                                                            <td>&nbsp;</td>
                                                        </tr>
                                                        <tr>
                                                            <td>CIP (ControlLogix/CompactLogix) : <b>44818</b></td>
                                                            <td>CompactLogix to SLC505 through ICX35</td>
                                                        </tr>
                                                        <tr>
                                                            <td>SLC/PLC5 : <b>2222</b></td>
                                                        </tr>
                                                        <tr>
                                                            <td>Modbus TCP/IP : <b>502</b></td>
                                                            <td style="font-size:9px;">
                                                                <label style="width: 110px;">Application</label> 
                                                                <label style="width: 110px;">Protocol</label> 
                                                                <label style="width: 110px;">LAN IP Address</label> 
                                                                <label style="width: 110px;">From Port Range</label>
                                                                <label style="width: 110px;">To Port Range</label>  
                                                            </td>
                                                        </tr>
                                                        <tr>
                                                            <td>DNP over Ethernet : <b>20000</b></td>
                                                            <td style="font-size:9px;">
                                                                <label style="width: 110px; font-weight: normal;">LXtoSLC</label> 
                                                                <label style="width: 110px; font-weight: normal;">TCP</label> 
                                                                <label style="width: 110px; font-weight: normal;">10.10.10.208</label> 
                                                                <label style="width: 110px; font-weight: normal;">44818 - 44818</label>
                                                                <label style="width: 110px; font-weight: normal;">2222 - 2222</label> 
                                                            </td>
                                                        </tr>
                                                        <tr>
                                                            <td>PROFINET : <b>8892</b></td>
                                                        </tr>
                                                    </table>
                                                </div>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td>
                                                <table width="100%" border="0" cellpadding="4" cellspacing="0">
                                                    <tr>
                                                        <td valign="top">
                                                            <table width="100%" border="0" cellpadding="4" cellspacing="0">
                                                                <tr>
                                                                    <td height="4" colspan="4" align="left" bgcolor="#4d92a8"></td>
                                                                </tr> 
                                                            </table>
                                                            <div id="divPortFWConfig" style="display:block;">
                                                                <table data-ng-init="loadData()" border="0" cellspacing="0" cellpadding="0">
                                                                    <tr>
                                                                        <td>
                                                                            <label>Enable:</label>
                                                                            <select name="portFwStatus" class="inputcol" style="width: 100px;" 
                                                                                                        ng-change="selectPortFwStatus()"         
                                                                                                        ng-model="portFwStatusList.defaultId" 
                                                                                                        ng-options="portFwStatus.portFwStatusId as portFwStatus.name for portFwStatus in portFwStatusList"
                                                                                                        required> 
                                                                            </select> 
                                                                        </td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td>
                                                                            <form name="fwForm" ng-submit="submitFWForm()" novalidate>
                                                                              <input type="hidden" name="csrf" value="<?php echo $_SESSION['csrf']; ?>" />
                                                                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                                                    <tr>
                                                                                        <td colspan="11">
                                                                                            <div class="form-group" style="font-size:11px; font-weight:bold;" ng-class="{ 'has-error' : fwForm.application.$invalid }">
                                                                                                <p ng-show="fwForm.application.$error.required" class="help-block" style="color:#f04040">Error: application name is required.</p>
                                                                                                <p ng-show="fwForm.application.$error.minlength" class="help-block" style="color:#f04040">Error: application name is too short.</p>
                                                                                                <p ng-show="fwForm.application.$error.maxlength" class="help-block" style="color:#f04040">Error: application name is too long.</p> 
                                                                                                <p ng-show="fwForm.application.$error.pattern"  class="help-block" style="color:#f04040">Error: application name should contain only alphanumeric characters.</p> 
                                                                                            </div>
                                                                                            <div class="form-group" style="font-size:11px; font-weight:bold;" ng-class="{ 'has-error' : fwForm.protocol.$invalid }">
                                                                                                <p ng-show="fwForm.protocol.$error.required" class="help-block" style="color:#f04040">Error: please select at least one value.</p> 
                                                                                            </div>  
                                                                                            <div class="form-group" style="font-size:11px; font-weight:bold;" ng-class="{ 'has-error' : fwForm.ipAddress.$invalid }">
                                                                                                <p ng-show="fwForm.ipAddress.$error.required" class="help-block" style="color:#f04040">Error: please complete the fowarding IP address.</p>
                                                                                                <p ng-show="fwForm.ipAddress.$error.minlength" class="help-block" style="color:#f04040">Error: the IP address is too short.</p>
                                                                                                <p ng-show="fwForm.ipAddress.$error.maxlength" class="help-block" style="color:#f04040">Error: the IP address is too long.</p> 
                                                                                                <p ng-show="fwForm.ipAddress.$error.pattern"  class="help-block" style="color:#f04040">Error: invalid IP address format.</p>
                                                                                            </div>     
                                                                                            <div class="form-group" style="font-size:11px; font-weight:bold;" ng-class="{ 'has-error' : fwForm.textFromIn.$invalid }">
                                                                                                <p ng-show="fwForm.textFromIn.$error.required" class="help-block" style="color:#f04040">Error: please complete the From Port lower value.</p>
                                                                                                <p ng-show="fwForm.textFromIn.$error.pattern"  class="help-block" style="color:#f04040">Error: invalid From Port lower value.</p>
                                                                                            </div> 
                                                                                            <div class="form-group" style="font-size:11px; font-weight:bold;" ng-class="{ 'has-error' : fwForm.textFromOut.$invalid }">
                                                                                                <p ng-show="fwForm.textFromOut.$error.required" class="help-block" style="color:#f04040">Error: please complete the From Port upper value.</p>
                                                                                                <p ng-show="fwForm.textFromOut.$error.pattern"  class="help-block" style="color:#f04040">Error: invalid From Port upper value.</p>
                                                                                            </div> 
                                                                                            <div class="form-group" style="font-size:11px; font-weight:bold;" ng-class="{ 'has-error' : fwForm.textToIn.$invalid }">
                                                                                                <p ng-show="fwForm.textToIn.$error.required" class="help-block" style="color:#f04040">Error: please complete the To Port lower value.</p>
                                                                                                <p ng-show="fwForm.textToIn.$error.pattern"  class="help-block" style="color:#f04040">Error: invalid To Port lower value.</p>
                                                                                            </div> 
                                                                                            <div class="form-group" style="font-size:11px; font-weight:bold;" ng-class="{ 'has-error' : fwForm.textToOut.$invalid }">
                                                                                                <p ng-show="fwForm.textToOut.$error.required" class="help-block" style="color:#f04040">Error: please complete the To Port upper value.</p>
                                                                                                <p ng-show="fwForm.textToOut.$error.pattern"  class="help-block" style="color:#f04040">Error: invalid To Port upper value.</p>
                                                                                            </div> 
                                                                                            <div class="form-group" style="color:#f04040; font-size:11px; font-weight:bold;" ng-class="{ 'has-error' : fwForm.$invalid }">
                                                                                                <p class="help-block" ng-show="!fwFormValid" style="color:#f04040">Error: {{fwWarningMessage}}</p>   
                                                                                                <p class="help-block" ng-show="!loggingBool" style="color:#f04040">Error: {{fwWarningMessage}}</p>
                                                                                            </div>
                                                                                        </td>
                                                                                    </tr>
                                                                                    <tr>
                                                                                        <td><label data-tip="Rule name indicating its general purpsose.">Application</label></td>
                                                                                        <td>&nbsp;</td>
                                                                                        <td><label data-tip="Traffic matching this protocol will be forwarded.">Protocol</label></td>
                                                                                        <td>&nbsp;</td>
            	                                                                        <td style="width: 195px;"><label data-tip="IP address of the destination LAN device.">LAN IP Address</label></td>
                                                                                        <td>&nbsp;</td>
            	                                                                        <td style="width: 200px;"><label data-tip="WAN port range to be forwarded to the LAN device.">From Port Range</label></td>
                                                                                        <td>&nbsp;</td>
            	                                                                        <td style="width: 200px;"><label data-tip="LAN device port range listening for forwarded traffic.">To Port Range</label></td>
                                                                                        <td>&nbsp;</td>
                                                                                        <td>&nbsp;</td>
                                                                                    </tr>
                                                                                    <tr>
            	                                                                        <td>
                                                                                            <!-- APPLICATION  min lenght 3, max lenght 12, only digits-->
                                                                                            <div style="width:145px; display: flex; vertical-align: middle; text-align: center;">
                                                                                                <input type="text" name="application" class="inputcol" 
                                                                                                    ng-model="application.text" 
                                                                                                    style="width: 110px;" 
                                                                                                    ng-minlength="3" 
                                                                                                    ng-maxlength="12" 
                                                                                                    required ng-pattern="/^[A-Za-z0-9_]*$/">
                                                                                            </div>
              	                                                                        </td>
                                                                                        <td>&nbsp;&nbsp;</td>
            	                                                                        <td>
                                                                                            <div style="width:145px; display: flex; vertical-align: middle; text-align: center;">
                                                                                                <select name="protocol" class="inputcol" style="width: 95px;" 
                                                                                                        ng-change="selectProtocol()"         
                                                                                                        ng-model="protocol" 
                                                                                                        ng-options="protocol.protocolId as protocol.name for protocol in protocols"
                                                                                                        required> 
                                                                                                <option value="">Select</option> 
                                                                                                </select>                                                                                           
                                                                                            </div>
              	                                                                        </td>
                                                                                        <td>&nbsp;&nbsp;</td>   
            	                                                                        <td>    
                                                                                            <div style="display: flex; width: 145px; vertical-align: middle; text-align: center;">
                                                                                                <input name="ipAddress" class="inputcol" style="width: 130px;" 
                                                                                                    ng-model="ipAddress" 
                                                                                                    ng-minlength="1" 
                                                                                                    ng-maxlength="15" 
                                                                                                    required ng-pattern="/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/"> 
                                                                                            </div>
              	                                                                        </td>
                                                                                        <td>&nbsp;&nbsp;</td>
            	                                                                        <td>
                                                                                            <div style="width:192px; display: flex; vertical-align: middle; text-align: center;">
                                                                                                <input type="text" name="textFromIn" class="inputcol" style="width: 80px;" 
                                                                                                    ng-model="fromPort.textFromIn" 
                                                                                                    ng-minlength="1" 
                                                                                                    ng-maxlength="5" 
                                                                                                    required ng-pattern="/^[1-9]{1}$|^[0-9]{2,4}$|^[0-9]{3,4}$|^[1-5]{1}[0-9]{1}[0-9]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-4]{1}[0-9]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-5]{1}[0-4]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-5]{1}[0-5]{1}[0-3]{1}[0-5]{1}$/"> 
                                                                                                <label >&nbsp; - &nbsp;</label>
                                                                                                <input type="text" name="textFromOut" class="inputcol" style="width: 80px;" 
                                                                                                    ng-model="fromPort.textFromOut" 
                                                                                                    ng-minlength="1" 
                                                                                                    ng-maxlength="5" 
                                                                                                    required ng-pattern="/^[1-9]{1}$|^[0-9]{2,4}$|^[0-9]{3,4}$|^[1-5]{1}[0-9]{1}[0-9]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-4]{1}[0-9]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-5]{1}[0-4]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-5]{1}[0-5]{1}[0-3]{1}[0-5]{1}$/"> 

                                                                                            </div>
            	                                                                        </td>
                                                                                        <td>&nbsp;&nbsp;</td>
              	                                                                        <td>   	               
                                                                                            <div style="width:192px; display: flex; vertical-align: middle; text-align: center;">
                                                                                                <input type="text" name="textToIn" class="inputcol" style="width: 80px;" 
                                                                                                    ng-model="toPort.textToIn" 
                                                                                                    ng-minlength="1" 
                                                                                                    ng-maxlength="5" 
                                                                                                    required ng-pattern="/^[1-9]{1}$|^[0-9]{2,4}$|^[0-9]{3,4}$|^[1-5]{1}[0-9]{1}[0-9]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-4]{1}[0-9]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-5]{1}[0-4]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-5]{1}[0-5]{1}[0-3]{1}[0-5]{1}$/"> 
                                                                                                <label>&nbsp; - &nbsp;</label>
                                                                                                <input type="text" name="textToOut" class="inputcol" style="width: 80px;" 
                                                                                                    ng-model="toPort.textToOut" 
                                                                                                    ng-minlength="1" 
                                                                                                    ng-maxlength="5" 
                                                                                                    required ng-pattern="/^[1-9]{1}$|^[0-9]{2,4}$|^[0-9]{3,4}$|^[1-5]{1}[0-9]{1}[0-9]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-4]{1}[0-9]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-5]{1}[0-4]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-5]{1}[0-5]{1}[0-3]{1}[0-5]{1}$/"> 
                                                                                            </div>	            
              	                                                                        </td>
                                                                                        <td>&nbsp;&nbsp;</td>
                                                                                        <td>
                                                                                            <div style="width:145px; display: block; vertical-align: middle; text-align: center;">
                                                                                                <button type="submit" class="copy"  style="width: 55px;" ng-disabled="fwForm.$invalid">Add</button> 
                                                                                                &nbsp;
                                                                                                <button class="copy" style="width: 65px;" ng-click="clearFields()" >Clear</button> 
                                                                                            </div>
                                                                                        </td>
                                                                                    </tr>
                                                                                </table>
                                                                            </form>
                                                                        </td>
                                                                    </tr>
                                                                    <tr><td>&nbsp;</td></tr>
                                                                    <tr>
                                                                        <td>
                                                                            <div class="gridStyle" ng-grid="gridOptions"></div>
                                                                        </td>
                                                                    </tr>
                                                                    <tr><td>&nbsp;</td></tr>
                                                                    <tr>
                                                                        <td>
                                                                            &nbsp;
                                                                            <label ng-model="errorMessage" ng-show="loggingBool"></label>
                                                                        </td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td>
                                                                            <div style="width:100%; display: flex; vertical-align: middle; text-align: center;">
                                                                                <button ng-click="deleteRows()" class="copy" style="width: 70px;">Delete</button> &nbsp; 
                                                                                <button ng-click="saveData()" class="copy" style="width: 70px;">Apply</button> 
                                                                            </div>                                                
                                                                        </td> 
                                                                    </tr>
                                                                </table>
                                                            </div>
                                                            <table width="100%" border="0" cellpadding="4" cellspacing="0">
                                                                <tr>
                                                                    <td height="4" colspan="4" align="left" bgcolor="#4d92a8"></td>
                                                                </tr> 
                                                            </table>
                                                        </td>
                                                    </tr>
                                                    <tr><td>&nbsp;</td></tr>
                                                </table>
                                            </td>
                                        </tr> 
                                        
                                    </table>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
        </td>
        <td background="/images/bgright.jpg">&nbsp;</td>
    </tr>
    <tr height=16>
        <td ><img src="/images/leftbtmangle.jpg" /></td>
        <td background="/images/bgbtm.jpg"></td>
        <td ><img src="/images/rightbtmangle.jpg" /></td>
    </tr>
</table>
<SCRIPT>
    <?php //Set the top menu style
    //alert(window.parent.document.getElementById("leftlink_configuration_basic")); ?>
    window.parent.document.getElementById("leftlink_configuration_basic").className = "leftNavLink";
    window.parent.document.getElementById("leftlink_configuration_advance").className = "leftNavLink";
    window.parent.document.getElementById("leftlink_configuration_firewall").className = "leftNavLinkActive";
</SCRIPT>
</body>
</html>
