<?php
    session_start();
    require_once('../inc/userfunction.php');
    require_once('../inc/systemfunction.php');
    require_once('../inc/json_services.php');

    // Check the login session
    if (CheckUserSession() == false) {
        header("Location: /components/session_expired.php");
        exit;
    }
    
    $method = $_SERVER['REQUEST_METHOD'];
    $csrf = $_POST['csrf'];
    
    // Check the CSRF token
    if (CheckCSRFToken($method, $csrf) == false) {
    	error_log("Warning! Possible CSRF detected.", 0);
    	exit;
    }

    $action = $_REQUEST['action'];
    if ($action == 1) {
        exec("/usr/bin/pkill -USR2 usaged", $pkillReturn);
        exec("/psft/bin/usageModify reset_periodusage", $usageResetted);
        header("Location: /components/status_home.php");
        exit(0);  
    }

    exec("/psft/bin/cellCmdRequest AT^SYSINFO", $sysInfo);
    exec("/psft/bin/pinHandler status", $simStatus);
    exec("/psft/bin/usageModify read", $usageData);
    exec("/psft/bin/gpioModify getSIMstatus", $simPresent);
    exec("/psft/bin/sharedStatModify --encap get", $serStat);
    exec("/psft/bin/sharedStatModify --device get", $devStat);

    $phoneStr = $devStat[0];
    $radioImei = $devStat[1];
    $RadioFWVer = $devStat[2];
    $ProvisionedCarrier = $devStat[3];

    preg_match_all('!\d+!', $sysInfo[3], $matches);
    $srvStatus  = $matches[0][0];
    $srvDomain  = $matches[0][1];
    $roamStatus = $matches[0][2];
    $sysMode    = $matches[0][3];

    if ((2 == $sysMode) || (4 == $sysMode) || (8 == $sysMode)) {
        /* 3G-CDMA */
        exec("/sbin/uqmi -sd /dev/cdc-wdm0 --get-signal-info", $signalval);

	   if ((4 == $sysMode) || (8 == $sysMode)) {
		  /* CDMA/HDR hybrid */
            $substrstart = strlen('"hdr","rssi":') + strpos($signalval[0], '"hdr"');
        } else {
            $substrstart = strlen('"cdma","rssi":') + strpos($signalval[0], '"cdma"');
    	}

        $substrend = strpos($signalval[0], ',', $substrstart);
        $signallevel = substr($signalval[0], $substrstart, $substrend - $substrstart);

        $NetReg = "";
        $ConType = 2;
    } else {
        exec("/psft/bin/cellCmdRequest AT+CSQ", $signalval);
        exec("/psft/bin/cellCmdRequest AT+COPS?", $cellNetwork);

        if ($cellNetwork[3] != "") {
            $substrstart = strpos($cellNetwork[3],'"');

    		if (FALSE == $substrstart) {
    			$NetReg = "Not Registered";
    			$ConType = -1;
    		} else {
                $substrend = strpos($cellNetwork[3], '"', $substrstart + 1);
                $NetReg = substr($cellNetwork[3], $substrstart + 1, $substrend - $substrstart - 1);
        		$ConType = substr($cellNetwork[3], $substrend + 2);
    		}

            /* CSQ to dBm conversion */
            $substrend = strpos($signalval[3], ',');
            $signallevel = 2 * substr($signalval[3], 6, $substrend - 6) - 113;
            if ($signallevel >= 0) {
              $signallevel = 0;
            }
        }
    }

    $IfConfigInfo = ifconfiginfo();
    $NetworkInfo = network();
    $BoardFWVer=GetBoardFWVer();

    if (!empty($NetworkInfo['ppp0'])) {
        $dataUsage = $usageData[2] + $NetworkInfo['ppp0']['tx_bytes'] + $NetworkInfo['ppp0']['rx_bytes'];
    } else {
        $dataUsage = $usageData[2] + $NetworkInfo['wwan0']['tx_bytes'] + $NetworkInfo['wwan0']['rx_bytes'];
    }
    $SerialNumber=$IfConfigInfo["eth0"]['macaddress'];
    $CfgRequest = "wan/datalimit wan/plansize2 wan/plansize1 ppp/redialtime " .
                  "encap/mode encap/modfilter wan/planbuffer wan/datablock " .
                  "ovpn/mode ipsec/mode ppp/roaming encap/role " .
                  " whitelist/wanlen ddns/mode system/eipenable";
    exec("/psft/bin/cfgModify readlist " . $CfgRequest, $CfgStarter);
    $CellPlanLimit = $CfgStarter[1] * 1024;
    for ($i = 0; $i < $CfgStarter[2]; $i++) {
        $CellPlanLimit *= 1024;
    }
    if ($dataUsage > $CellPlanLimit) {
        $textcellusagegraph = graph_cellularusage($CellPlanLimit, $CellPlanLimit);
    } else {
        $textcellusagegraph = graph_cellularusage($dataUsage, $CellPlanLimit);
    }

    date_default_timezone_set("UTC");
    $linkSeconds = date("U") - $usageData[7];
    $pppRedialTime = $CfgStarter[3];
    exec("/usr/bin/pgrep pppwd", $pppdPID);

    /* Set $signalgraph */
    if ($signallevel >= -103) {
        if ($signallevel >= -95) {
            if ($signallevel >= -85) {
                if ($signallevel >= -75) {
                    $litCnt = 4;
                    if ($signallevel >= 0) {
                        $litCnt = 0;
                    }
                } else {
                    $litCnt = 3;
                }
            } else {
                $litCnt = 2;
            }
        } else {
            $litCnt = 1;
        }
    } else {
        $litCnt = 0;
    }

    for ($i = 0; $i < $litCnt; $i++) {
        $signalgraph .= '<img src="../../images/LitGreenLED10_15.bmp"/>';
    }

    for ($i = 0; $i < (4 - $litCnt); $i++) {
        $signalgraph .= '<img src="../../images/UnlitGreenLED10_15.bmp"/>';
    }

    /* Set $cellStatus */
    exec("/psft/bin/sharedStatModify --wan get", $wanConnState);
    switch ($wanConnState[0]) {
        case '1':
            $cellStatus = '<span class="style2">Connected</span>';
            $connected = 1;
            break;
        case '2':
            $cellStatus = '<span class="style3">Disabled - Usage Limit Exceeded</span>';
            break;
        default:
            if ($simPresent[0]) {
                $cellStatus = '<span class="style3">SIM not found</span>';
            } else if ("SIM PIN" == $simStatus[0]) {
                $cellStatus = '<table width="450" border=0 align="left" cellspacing=0 style="margin:0px;">' .
                              '<tr><td width="238"><span class="style3">SIM locked</span></td>' .
                              '<td width="218" onClick="window.parent.location=\'/configuration.php\'" style="cursor:pointer; color:#00F;">Unlock</td></tr></table>';
            } else if ("SIM PUK" == $simStatus[0]) {
                $cellStatus = '<table width="450" border=0 align="left" cellspacing=0 style="margin:0px;">' .
                              '<tr><td width="238"><span class="style4">SIM blocked</span></td>' .
                              '<td width="218" onClick="window.parent.location=\'/configuration.php\'" style="cursor:pointer; color:#00F;">Unblock</td></tr></table>';
            } else if ((1 == $roamStatus) && ($CfgStarter[10] == "0")) {
                $cellStatus = '<span class="style3">Roaming and disabled</span>';
            } else if ((NULL != $pppdPID) && (0 != $pppRedialTime[0])) {
                $cellStatus = '<span class="style3">Connecting...</span>';
            } else if ((NULL != $pppdPID) && (0 == $pppRedialTime[0])) {
                $cellStatus = '<span class="style3">Disconnected, will not retry</span>';
            } else {
                $cellStatus = '<span class="style3">Disconnected, will retry</span>';
            }
    }

    /* Set $ipsecConnState */
    exec("/psft/bin/sharedStatModify --vpn get", $ipsecConnState);
    $DDNSMode = $CfgStarter[13];
    $EIPMode = $CfgStarter[14];
    $SerEncapMode = $CfgStarter[4];
    $ModFilter = $CfgStarter[5];
    $SerEncapModeTable = array("Disabled","Generic Encapsulation","Modbus RTU",
                               "Modbus ASCII","Modbus RTU -> ModbusTCP", "Modbus ASCII -> ModbusTCP",
                               "DF1 Half-Duplex","DF1 Full-Duplex","DF1 Radio Modem");
    $SerEncapRoleTable = array("Client","Server","Client/Server","Master","Slave");

    /* Check ethernet connection status */
    $ethConnFile = fopen("/sys/class/net/eth0/carrier", "r");
    $ethConnStatus = fread($ethConnFile, filesize("/sys/class/net/eth0/carrier"));
    fclose($ethConnFile);

    if ($ethConnStatus == 0) {
        /* If $ethConnStatus == 0, result is eth NOT connected */
        $ethConn = "<span class='style4'>Link Down</span>";
    } elseif ($ethConnStatus == 1) {
        /* If $ethConnStatus == 1, result is eth IS connected */
        $ethSpeedFile = fopen("/sys/class/net/eth0/speed", "r");
        $ethSpeed = fread($ethSpeedFile, filesize("/sys/class/net/eth0/speed"));
        $ethSpeed = trim($ethSpeed);
        fclose($ethSpeedFile);
  
        /* Get network duplex */
        $ethDuplexFile = fopen("/sys/class/net/eth0/duplex", "r");
        $ethDuplex = fread($ethDuplexFile, filesize("/sys/class/net/eth0/duplex"));
        fclose($ethDuplexFile);

        /* Display eth status, and speed/duplex for Connection Status */
        $ethConn = "<span class='style2'>Link Up - $ethSpeed/$ethDuplex</span>";
    }
?>

<html>
    <head>
        <title>ProSoft</title>
        <meta HTTP-EQUIV="Pragma" CONTENT="no-cache">
        <meta HTTP-EQUIV="Expires" CONTENT="-1">
        <meta http-equiv="refresh" content="20">
        <link type="text/css" href="/css/styles.css" rel="stylesheet">
        <script src="/scripts/jquery.min.js" type="text/JavaScript"></script>
        <script src="/js/application.js" type="text/JavaScript"></script>
        <script src="/js/main.js" type="text/JavaScript"></script>
        <script> var currentsubmenu = 'leftlink_status_home';</SCRIPT>
        <style type="text/css">
            .style2 {
                color: #000000;
                background-color: #00FF33;
            }
            .style3 {
                color: #000000;
                background-color: #FFFF33;
            }
            .style4 {
                color: #000000;
                background-color: #FF3333;
            }
        </style>
    </head>
    <body leftmargin="0" topmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" onload='parent.resizeIframe(document.body.scrollHeight)' ng-app="LightDocs">
        <?php /* <!-- Start tabs --> */ ?>
        <table width=100% height="580" cellpadding="0" cellspacing="0" style="padding:0">
            <tr height=13 >
                <td width=14 >
                    <img src="../../images/leftopangle.jpg" />
                </td>
                <td background="../../images/bgtop.jpg" ></td>
                <td width=14 >
                    <img src="../../images/rightopangle.jpg" />
                </td>
            </tr>
            <tr>
                <td background="/images/bgleft.jpg" >&nbsp;</td>
 	 	        <td align="center" valign="top">
                    <table width="100%" border="0" align="left" cellpadding="0" cellspacing="0">
                        <tr>
                            <td colspan="4" height="10">
                                <hr color="#4d92a8"/>
                            </td>
                        </tr>
                        <tr>
                            <td width="36" align="center">&nbsp;</td>
                            <td width="22" align="center">&nbsp;</td>
                            <td width="27">&nbsp;</td>
                            <td width="876">
                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                    <tr>
                                        <td width="130">
                                            <strong>System</strong>
                                        </td>
                                        <td>&nbsp;</td>
                                    </tr>
                                    <tr>
                                        <td>&nbsp;</td>
                                        <td align="left" valign="top">
                                            <table width="450" border=0 align="left" cellspacing=0 style="margin:5px;">
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td width="228">Up Time</td>
                                                    <td width=218 ><?php echo uptimestr(uptime()); ?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>System Time </td>
                                                    <td width=218 ><?php echo gmdate("Y-m-d H:i:s",time());?> UTC</td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Board F/W Version </td>
                                                    <td width=218 ><?php echo $BoardFWVer;?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Radio F/W Version </td>
                                                    <td width=218 ><?php echo "$RadioFWVer $ProvisionedCarrier";?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Serial Number</td>
                                                    <td width=218 ><?php echo $SerialNumber;?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>IMEI</td>
                                                    <td width=218 ><?php echo $radioImei;?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Phone Number</td>
                                                    <td width=218 ><?php echo $phoneStr;?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>ProSoft Connect</td>
                                                    <td width=218>
                                                        <div>
                                                            <?php
                                                                $decoded = null;
                                                                $error = ''; 
                                                                $fileContent = '';
                                                                $json = new Services_JSON();

                                                                try {
                                                                    $fileContent = file_get_contents('/psft/bin/agentInfo.json');
                                                                    /* Decode the original Json File */
                                                                    $decoded = $json->decode($fileContent); 
                                                                }
                                                                catch(Exception $e) {
                                                                    $error = $e->getMessage();
                                                                }

                                                                $stringValue = '';
                                                                if ($decoded->Connection->state == 'connected') {
                                                                    $stringValue = 'Connected';
                                                                } else if ($decoded->Connection->state == 'disconnected') {
                                                                    $stringValue = 'Disconnected';
                                                                } else if ($decoded->Connection->state == 'failed'){
                                                                    $stringValue = 'Failed';
                                                                } else {
                                                                    $stringValue = 'Failed';
                                                                }

                                                                if ($decoded->Connection->state == 'connected') {
                                                                    $stringValue .=' , ';
                                                                    if ($decoded->Activation->status == 'NOT_ACTIVATED') {
                                                                        $stringValue .= 'Deactivated';
                                                                    } else if($decoded->Activation->status == 'ACTIVATED') {
                                                                        $stringValue .= 'Activated';
                                                                    }
                                                                }

                                                                echo  $stringValue ;
                                                            ?>
                                                        </div>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="4" height="10"><hr color="#4d92a8"/></td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>
                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                    <tr>
                                        <td width="130">
                                            <b>WAN</b>
                                        </td>
                                        <td align="left" valign="top"><?php echo $cellStatus;?></td>
                                    </tr>
                                    <tr>
                                        <td>&nbsp;</td>
                                        <td align="left" valign="top">
                                            <table width="450" border=0 align="left" cellspacing=0 style="margin:5px;">
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td width="228">Connection  Type </td>
                                                    <td width=218><?php if (-1 == $ConType) {echo "No Service";} if (0 == $ConType) {echo "GSM";} if (2 == $ConType) {echo "3G";} if (7 == $ConType) {echo "4G-LTE";}?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Signal  Level </td>
                                                    <td width=218><?php echo $signalgraph . "&nbsp;&nbsp;" . $signallevel . "dBm";?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Network  Registration </td>
                                                    <td width=218><?php echo $NetReg;?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Link  Time </td>
                                                    <td width=218>
                                                        <?php
                                                            if (1 == $connected) {
                                                                if ($linkSeconds > 60000000) {
                                                                    echo "Date not set at link time.";
                                                                } else {
                                                                    echo uptimestr($linkSeconds);
                                                                }
                                                            }
                                                        ?>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Disconnect Count</td>
                                                    <td width=218><?php echo $usageData[8];?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>IP</td>
                                                    <td width=218><?php if ("" != $IfConfigInfo['wwan0']['ipaddress']) {echo $IfConfigInfo['wwan0']['ipaddress'];} else {echo $IfConfigInfo['ppp0']['ipaddress'];}?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Sent Bytes </td>
                                                    <td><?php if ("" != $IfConfigInfo['wwan0']['ipaddress']) {echo ($NetworkInfo['wwan0']['tx_bytes'] - $usageData[14]); } else {echo $NetworkInfo['ppp0']['tx_bytes'] ;}?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>  Received Bytes </td>
                                                    <td width=218><?php if ("" != $IfConfigInfo['wwan0']['ipaddress']) {echo ($NetworkInfo['wwan0']['rx_bytes'] - $usageData[13]); } else {echo $NetworkInfo['ppp0']['rx_bytes'] ;}?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>  Sent SMS </td>
                                                    <td width=218><?php echo $usageData[10];?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>  Received SMS </td>
                                                    <td width=218><?php echo $usageData[9];?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Whitelist</td>
                                                    <td width=218>
                                                        <?php
                                                            if ($CfgStarter[12] > 0) {echo "Enabled";} else {echo "Disabled";}
                                                        ?>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="4" height="10"><hr color="#4d92a8"/></td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>
                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                    <tr>
                                        <td width="130">
                                            <strong>Cellular Data Usage</strong>
                                        </td>
                                        <td align="left" valign="top">
                                            <table width="450" border=0 align="left" cellspacing=0 style="margin:0px;">
                                                <tr>
                                                    <td width="238">
                                                        <?php
                                                            if ($CfgStarter[0]) {
                                                                echo '<span class="style2">Enabled </span>';
                                                            } else {
                                                                echo '<span class="style3">Disabled </span>';
                                                            }
                                                        ?>
                                                        &nbsp;&nbsp;
                                                        <?php
                                                            echo($textcellusagegraph);
                                                        ?>
                                                    </td>
                                                    <td width=218>
                                                        <?php
                                                            if ($CfgStarter[0]) echo round($dataUsage/$CellPlanLimit*100) . "%&nbsp;&nbsp(&nbsp;" . round($dataUsage/1024) ." kB / " . round($CellPlanLimit/1024) . " kB&nbsp;)";
                                                        ?>
                                                    </td>
                                                    <td>
                                                        <form action="status_home.php?action=1" method="post">
                                                            <input type="hidden" name="csrf" value="<?php echo $_SESSION['csrf']; ?>" />
                                                            <input name="reset_cellperiod" type="submit" id="reset_cellperiod" value="Reset Period Usage" class="copy">
                                                        </form>
                                                    </td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>&nbsp;</td>
                                        <td align="left" valign="top">
                                            <table width="450" border=0 align="left" cellspacing=0 style="margin:5px;">
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td width="228">Current Period</td>
                                                    <td width=218><?php echo $dataUsage;?></td>
                                                </tr>
                                                <?php
                                                    if ($CfgStarter[0]) {
                                                        printf('<tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                                <tr> <td>Previous Period</td> <td>%u</td> </tr>
                                                                <tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                                <tr> <td>Current Day</td> <td width=218>%u</td> </tr>
                                                                <tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                                <tr> <td>Previous Day</td> <td>%u</td> </tr>',
                                                                $usageData[1], $usageData[5], $usageData[6]);
                                                }?>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="4" height="10">
                                <hr color="#4d92a8"/>
                            </td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>
                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                    <tr>
                                        <td width="130">
                                            <strong>LAN</strong>
                                        </td>
                                        <td >&nbsp;</td>
                                    </tr>
                                    <tr>
                                        <td>&nbsp;</td>
                                        <td align="left" valign="top">
                                            <table width="450" border=0 align="left" cellspacing=0 style="margin:5px;">
                                                <tr>
                                                    <td width="228">Connection Status</td>
                                                    <td width=218>
                                                        <?php echo $ethConn; ?>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td width="228">IP Address</td>
                                                    <td width=218><?php echo $IfConfigInfo['eth0']['ipaddress']; ?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Netmask</td>
                                                    <td width=218><?php echo $IfConfigInfo['eth0']['subnetmask']; ?></td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Ethernet Address (MAC)</td>
                                                    <td >
                                                        <?php echo $IfConfigInfo['eth0']['macaddress']; ?>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Received Bytes</td>
                                                    <td>
                                                        <?php echo ($NetworkInfo['eth0']['rx_bytes'] - $usageData[11]); ?>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                                <tr>
                                                    <td>Sent Bytes</td>
                                                    <td>
                                                        <?php echo ($NetworkInfo['eth0']['tx_bytes'] - $usageData[12]); ?>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td colspan=2 height=1 style="background:#B6B5BA"></td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="4" height="10"><hr color="#4d92a8"/></td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>
                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                    <tr>
                                        <td width="130">
                                            <strong>DDNS</strong>
                                        </td>
                                        <td>
                                            <?php
                                                if (0 == $DDNSMode) {
                                                    echo '<span class="style3">Disabled </span>';
                                                } elseif (1 == $DDNSMode) {
                                                    echo '<span class="style2">DynDNS Enabled</span>';
                                                } elseif (2 == $DDNSMode) {
                                                    echo '<span class="style2">No-IP Enabled</span>';
                                                }
                                            ?>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="4" height="10">
                                <hr color="#4d92a8"/>
                            </td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>
                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                    <tr>
                                        <td width="130">
                                            <strong>VPN</strong>
                                        </td>
                                        <td>
                                            <?php
                                                if ($CfgStarter[8] == 5) {
                                                    if (array_key_exists("tun0",$IfConfigInfo)) {
                                                        echo '<span class="style2">OpenVPN Tunnel Connected </span>';
                                                    } else {
                                                        echo '<span class="style2">OpenVPN Tunnel Enabled.  Connecting... </span>';
                                                    }
                                                } elseif ($CfgStarter[9] != 0) {
                                                    if ($ipsecConnState[0] == "1") {
                                                        echo '<span class="style2">IPSec Tunnel Connected </span>';
                                                    } else {
                                                        echo '<span class="style2">IPSec Tunnel Enabled.  Connecting... </span>';
                                                    }
                                                } else {
                                                    echo '<span class="style3">Disabled </span>';
                                                }
                                            ?>
                                        </td>
                                    </tr>
                                    <?php
                                        if ($CfgStarter[8] == 5) {
                                            echo "  <tr>
                                                    <td>&nbsp;</td>
                                                    <td align='left' valign='top'><table width='450' border=0 align='left' cellspacing=0 style='margin:5px;'>
                                                    <tr> <td colspan=2 height=1 style='background:#B6B5BA'></td> </tr>
                                                    <tr>
                                                    <td width='228'>IP Address</td>
                                                    <td>" . $IfConfigInfo['tun0']['ipaddress'] . "</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style='background:#B6B5BA'></td> </tr>
                                                    <tr>
                                                    <td>Received Bytes</td>
                                                    <td>" . $NetworkInfo['tun0']['rx_bytes'] . "</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style='background:#B6B5BA'></td> </tr>
                                                    <tr>
                                                    <td>Sent Bytes</td>
                                                    <td>" . $NetworkInfo['tun0']['tx_bytes'] . "</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style='background:#B6B5BA'></td> </tr>
                                                    </table></td>
                                                    </tr>";
                                        } elseif ($CfgStarter[9] != 0) {
                                            echo "  <tr>
                                                    <td>&nbsp;</td>
                                                    <td align='left' valign='top'><table width='450' border=0 align='left' cellspacing=0 style='margin:5px;'>
                                                    <tr> <td colspan=2 height=1 style='background:#B6B5BA'></td> </tr>
                                                    <tr>
                                                    <td width='228'>IP Address</td>
                                                    <td>" . $IfConfigInfo['ipsec0']['ipaddress'] . "</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style='background:#B6B5BA'></td> </tr>
                                                    <tr>
                                                    <td>Received Bytes</td>
                                                    <td>" . $NetworkInfo['ipsec0']['rx_bytes'] . "</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style='background:#B6B5BA'></td> </tr>
                                                    <tr>
                                                    <td>Sent Bytes</td>
                                                    <td>" . $NetworkInfo['ipsec0']['tx_bytes'] . "</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style='background:#B6B5BA'></td> </tr>
                                                    </table></td>
                                                    </tr>";
                                        }
                                    ?>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="4" height="10">
                                <hr color="#4d92a8"/>
                            </td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>
                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                    <tr>
                                        <td width="130">
                                            <strong>Serial</strong>
                                        </td>
                                        <td>
                                            <?php
                                                if (0 == $SerEncapMode[0]) {
                                                    echo '<span class="style3">Disabled </span>';
                                                } else {
                                                    $SerEncapRoleTableIndex = $CfgStarter[11];
                                                    echo '<span class="style2">' . $SerEncapModeTable[$SerEncapMode[0]];
                                                    if (($SerEncapMode > 1) && ($SerEncapMode < 6)) {
                                                        $SerEncapRoleTableIndex = $SerEncapRoleTableIndex + 3;
                                                        echo ' connected to a ';
                                                    } else {
                                                        echo ' as a ';
                                                    }
                                                    echo $SerEncapRoleTable[$SerEncapRoleTableIndex] . '</span>';
                                                }
                                            ?>
                                        </td>
                                    </tr>
                                    <?php
                                        if (0 != $SerEncapMode[0]) {
                                            printf('<tr>
                                                    <td>&nbsp;</td>
                                                    <td align="left" valign="top"><table width="450" border=0 align="left" cellspacing=0 style="margin:5px;">
                                                    <tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                    <tr>
                                                    <td width="228">Received Bytes </td>
                                                    <td width="218">%d</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                    <tr>
                                                    <td>Sent Bytes </td>
                                                    <td>%d</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                    <tr>
                                                    <td>Dropped Bytes</td>
                                                    <td>%d</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                    <tr>
                                                    <td>Dropped Serial Messages</td>
                                                    <td>%d</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                    <tr>
                                                    <td>Received Encapsulated Messages</td>
                                                    <td>%d</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                    <tr>
                                                    <td>Sent Encapsulated Messages</td>
                                                    <td>%d</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                    <tr>
                                                    <td>Sent Encapsulated Bytes</td>
                                                    <td>%d</td>
                                                    </tr>
                                                    <tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                    <tr>
                                                    <td>Dropped Encapsulated Messages</td>
                                                    <td>%d</td>
                                                    </tr>',
                                                    $serStat[4], $serStat[6], $serStat[1], $serStat[0], $serStat[7], $serStat[2], $serStat[3], $serStat[8]);

                                            if ((1 < $SerEncapMode[0]) && (6 > $SerEncapMode[0]) && $ModFilter[0]) {
                                                printf('<tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                        <tr>
                                                        <td>Modbus CRC Errors</td>
                                                        <td>%d</td>
                                                        </tr>',
                                                        $serStat[5]);
                                            }
                                            printf('<tr> <td colspan=2 height=1 style="background:#B6B5BA"></td> </tr>
                                                    </table></td>
                                                    </tr>');
                                        }
                                    ?>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="4" height="10">
                                <hr color="#4d92a8"/>
                            </td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td>
                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                    <tr>
                                        <td width="130">
                                            <strong>E/IP</strong>
                                        </td>
                                        <td>
                                            <?php
                                                if (0 == $EIPMode[0]) {
                                                    echo '<span class="style3">Disabled </span>';
                                                } else {
                                                    echo '<span class="style2">Enabled </span>';
                                                }
                                            ?>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="4" height="10">
                                <hr color="#4d92a8"/>
                            </td>
                        </tr>
                    </table>
                </td>
 	 	        <td background="/images/bgright.jpg">&nbsp;</td>
            </tr>
            <tr height=16>
 	 	        <td >
                    <img src="/images/leftbtmangle.jpg" />
                </td>
 	 	        <td background="/images/bgbtm.jpg"></td>
                <td>
                    <img src="/images/rightbtmangle.jpg" />
                </td>
            </tr>
        </table>
        <?php /* End body */ ?>
    </body>
</html>
