<?php
header("Cache-Control: no-store, no-cache, must-revalidate, max-age=0");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

require_once('../inc/systemfunction.php');
require_once('../inc/json_services.php');  

class ConnectionDetails
{
    public $encoded = ''; 
    function getConnectionDetails()
    {
        $validSettings = false;
        $decoded = null;
        $error = ''; 
        $fileContent = '';
        $json = new Services_JSON();
        try
        {
            $fileContent = file_get_contents('/psft/bin/agentInfo.json');
            //decode the original Json File
            $decoded = $json->decode($fileContent); 
            $validSettings = true;
        }
        catch(Exception $e)
        {
            $error = $e->getMessage();
            $validSettings = false;
        }
         
        //recombine the response in order to contain the error message
        $response = array(); 
        $response['Connection'] = $decoded->Connection;
        $response['Activation'] = $decoded->Activation;
        $response['LastKnownState'] = $decoded->LastKnownState;
        $response['ErrorMessage'] = $error;
        $response['ValidSettings'] = $validSettings;
        $encoded = $json->encode($response);    
            
        // encode array $json to JSON string
        $encoded = str_replace('[','',$encoded);
        $encoded = str_replace(']','',$encoded);  
        $encoded = str_replace(' ','',$encoded); 

        return $encoded;
    }
}

// send response back to java and end script execution
die( (new ConnectionDetails()) -> getConnectionDetails() );  

?>