<?php
    require_once('../inc/systemfunction.php');
    require_once('../inc/json_services.php');

    class DeviceFirewallHandler {
        function setConfiguration() {
            $ptEnabled = trim($_GET['ptEnabled']);
            $ptAddress = trim($_GET['ptAddress']);
            $fwData = trim($_GET['fwData']);
            $fwEnabled = trim($_GET['fwEnabled']);

            $json = new Services_JSON();
            $error = '';
            $saveState = false;
            try {
                /* Enable/Disable pass through */
                ConfigWrite('lan/passthrough', $ptEnabled);
                ConfigWrite('lan/devipadr0', $ptAddress);

                for ($i = 0; $i <= 9; $i++) {
                /* Write to configuration file */
                ConfigWrite('firewall/portfw'.$i,'');
                }

                /* Enable/Disable port fowarding */
                ConfigWrite('firewall/enableportfw', $fwEnabled);

                /* Decoding the Json Data */
                $fwDataDecoded = $json->decode($fwData);

                $iterator = 0;
                foreach ($fwDataDecoded as &$value) {
                    $enceodedString = '';
                    /* Serialise the data */
                    $enceodedString .= $value->Application.';';
                    $enceodedString .= $value->Protocol.';';
                    $enceodedString .= $value->FromBeginPort.';';
                    $enceodedString .= $value->FromEndPort.';';
                    $enceodedString .= $value->IpAddress.';';
                    $enceodedString .= $value->ToBeginPort.';';
                    $enceodedString .= $value->ToEndPort;

                    /* Write in the configuration file */
                    ConfigWrite('firewall/portfw'.$iterator, $enceodedString);
                    $iterator++;
                }

                /* commit the changes */
                ConfigToFlash();

                /* Load firewall rules */
                LoadFirewall();

                $saveState = true;
            }
            catch (Exception $e) {
                $error = $e->getMessage();
            }

            $response = array();
            $response['SaveState'] = $saveState;
            $response['ErrorMessage'] = $error;
            $encoded = $json->encode($response);
            
            return $saveState;
        }
    }

    /* Send response back to java and end script execution */
    die((new DeviceFirewallHandler()) -> setConfiguration());
?>