var myApp = angular.module("LightDocs", []);     

myApp.controller('CloudCtrl', function ($scope, $http, $interval)
{
    $scope.errorMessageX = '';
    $scope.notificationMessage = '';
    $scope.isConnectedBool = 'true';

    $interval(function () {

        //$scope.connect controlls the logic for the buttton if reconecting or not
        try {
            $http({ method: 'GET', url: '/inc/cloud_connection_status.php' })
            .success(function (data) {
                //return status from .config file
                $scope.response = data;
                if ($scope.response.IsConnected.indexOf('true') != -1)
                    $scope.isConnectedBool = true;
                else
                    $scope.isConnectedBool = false;
                //return the php error message in case exists
                $scope.errorMessage = $scope.response.ErrorMessage;
            })
            .error(function (response) {
                $scope.loggingBool = true;
                $scope.errorMessage = response;
                $scope.isConnectedBool = false;
            });


            $http({ method: 'GET', url: '/inc/cloud_connection_details.php' })
             .success(function (data) {
                 //return data from Json file
                 $scope.settings = data.JsonMessage;
                 //return the php error message in case exists
                 $scope.errorMessage = data.ErrorMessage;
             })
              .error(function (response) {
                  $scope.loggingBool = true;
                  $scope.errorMessage = response;
                  $scope.isConnectedBool = false;
              });

            if ($scope.settings != null) {;
                if ($scope.settings.Connection.state.indexOf('disconnected') != -1) {
                    $scope.isConnectedString = 'Disconnected';
                    $scope.notificationMessage = 'Cloud it is now disconnected. Please connect your device to the cloud in order to activate it!'
                    scope.isActivatedingBool = false;
                    $scope.buttonString = 'Connect';
                }
                else if ($scope.settings.Connection.state.indexOf('failed') != -1) {
                    $scope.isConnectedString = 'Failed';
                    $scope.notificationMessage = 'Cloud failed to connet. Please connect your administrator!'
                    scope.isActivatedingBool = false;
                    $scope.buttonString = 'Connect';
                }
                else {
                    $scope.isConnectedString = 'Connected';
                    if ($scope.settings.Activation.status == 'ACTIVATED')
                        $scope.notificationMessage = 'Your device it is now connected and activated.';
                    else
                        $scope.notificationMessage = 'Your device it is now connected. Please activate your device!';
                }

                if ($scope.isConnectedBool) {
                    if ($scope.settings.Activation.status == 'ACTIVATED') {
                        $scope.buttonString = 'Deactivate';
                        $scope.isActivatedString = 'Activated';
                        $scope.isActivatedBool = true;
                        $scope.isActivatedingBool = false;
                    }
                    else if ($scope.settings.Activation.status == 'NOT_ACTIVATED') {
                        if ($scope.settings.Activation.key.lenght != 0) {
                            $scope.buttonString = 'Activating';
                            $scope.isActivatedString = 'Activating';
                            $scope.isActivatedingBool = true;
                        }
                        else {
                            $scope.buttonString = 'Activate';
                            $scope.isActivatedString = 'Activate';
                            $scope.isActivatedingBool = false;
                        }

                        scope.isActivatedBool = false;
                    }
                }
                else {
                    $scope.buttonString = 'Connect';
                    scope.isActivatedingBool = false;
                    $scope.notificationMessage = 'Cloud it is now disconnected. Please connect your device to the cloud in order to activate it!'
                }
            }
        }
        catch (err) {
            $scope.isConnectedString = 'Disconnected';
            $scope.isConnectedBool = false;

            $scope.isActivatedString = 'Deactivated';
            scope.isActivatedBool = false;

            $scope.loggingBool = true;
            $scope.errorMessage = err.message;
        }

    }, 2000);

    $scope.connectToCloud = function ()
    {  
        try
        {
            if ($scope.isActivatedingBool) {
                $scope.notificationMessage = 'Please wait untill your deveice it is activated!'
                return;
            }

            $http({ method: 'GET', url: '/inc/cloud_connection_manager.php', params: { connection_status: !$scope.isConnectedBool } })
            .success(function (data)
            {
                $scope.errorMessageX = data.ErrorMessage;
                if ($scope.isConnectedBool)
                    $scope.buttonString = 'Connected';

                $scope.logging = false;
                $scope.message = data;
            })
            .error(function (response)
            {
                $scope.logging = true;
                $scope.errorMessage = response;
                $scope.connected = false;
            });
        }
        catch (err)
        {
            $scope.logging = true;
            $scope.errorMessage = err.message;
            $scope.connected = false;
        }
    };
});